package org.udg.tfg.javaee.model;

import java.io.Serializable;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.validation.constraints.NotNull;
import com.fasterxml.jackson.annotation.JsonIgnore;

@Entity
public class Ubicacion implements Serializable {

	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	protected Long id;

	@NotNull
	private double latitud;

	@NotNull
	private double longitud;

	@NotNull
	private String direccion;

	@JsonIgnore
	@ManyToOne(fetch = FetchType.EAGER)
	private Municipio municipio;

	public Ubicacion() {

	}

	public Ubicacion(double latitud, double longitud, String direccion, Municipio municipio) {
		this.latitud = latitud;
		this.longitud = longitud;
		this.direccion = direccion;
		this.municipio = municipio;

	}

	public Long getId() {
		return id;
	}

	public double getLatitud() {
		return latitud;
	}

	public void setLatitud(double latitud) {
		this.latitud = latitud;
	}

	public double getLongitud() {
		return longitud;
	}

	public void setLongitud(double longitud) {
		this.longitud = longitud;
	}

	public String getDireccion() {
		return direccion;
	}

	public void setDireccion(String direccion) {
		this.direccion = direccion;
	}

	public Municipio getMunicipio() {
		return municipio;
	}

	public void setMunicipio(Municipio municipio) {
		this.municipio = municipio;
	}

}
